package cmdUser

import (
	u "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/client/utils"
	nc "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/libclient/nexusclient"
)

type Whoami struct {
	Name string
}

func (cmd *Whoami) GetName() string {
	return cmd.Name
}

func (cmd *Whoami) GetDesc() []string {
	return []string{
		"Displays the current user's details."}
}

func (cmd *Whoami) PrintUsage() {
	for _, desc := range cmd.GetDesc() {
		u.PrintlnErr(desc)
	}
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
	u.PrintlnErr("USAGE: " + cmd.GetName())
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
}

func (cmd *Whoami) Run(client *nc.NexusClient, args []string) int {
	if len(args) > 0 {
		cmd.PrintUsage()
		return 1
	}

	user, err := client.UserWhoAmI()
	if err != nil {
		u.PrintlnErr(err)
		return 1
	}

	u.Println(user.String())
	return 0
}
