package nexusclient

import (
	"encoding/json"
	"errors"

	"gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/common/params"
)

func (nc *NexusClient) GetServerVersion() (*params.Version, error) {
	resp, err := nc.client.R().Get("/version")
	if err != nil {
		return nil, err
	} else {
		if resp.IsSuccess() {
			version := params.Version{}
			if err := json.Unmarshal(resp.Body(), &version); err != nil {
				return nil, err
			}
			return &version, nil
		} else {
			return nil, errors.New(resp.Status() + ": " + resp.String())
		}
	}
}

// TODO:
// - Expose a method that returns a message with the content below
// - Update nexush, nexus-cli and nexus-exam accordingly
//
// clientVersion := version.Get()
// u.PrintlnErr(appname + " version " + clientVersion.String() + " (commit " + buildversion.GitCommit() + ")")
// u.PrintlnErr("Built on " + buildversion.BuildDate())
